#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

int correctLanternsCount(int n, long long a, long long x, long long b, long long y) {
   if (x < y) {
      swap(a, b);
      swap(x, y);
   }
   if (a * (2 * x + 1) + b * (2 * y + 1) < n) {
      return -1;
   }
   int bigLanternsCount = min(a, (n + 2 * x) / (2 * x + 1));
   if (bigLanternsCount * (2 * x + 1) >= n) {
      return bigLanternsCount;
   }
   int rest = n - bigLanternsCount * (2 * x + 1);
   int smallLanternsCount = (rest + 2 * y) / (2 * y + 1);
   assert(smallLanternsCount <= b);
   return bigLanternsCount + smallLanternsCount;
}

int solutionLanternsCount(int n, long long a, long long x, 
                          long long b, long long y,
                          InStream &stream, TResult wa_res, TResult pe_res
                      ) {
   int pos = stream.readInt();
   if (pos == -1) {
      return -1;
   }
   if (pos < 1 || pos > n) {
        quitf(wa_res, "The first number in the response must be between 1 and %d or -1, but %d is in the output", n, pos);
   }
   vector<bool> used(n + 1);
   vector<int> light(n + 2);
   int dist = stream.readInt();
   int index = 1;
   for(;;index++) {
       if (pos < 1 || pos > n) {
           quitf(wa_res, "Lantern number %d has invalid coordinate %d", index, pos);
       }
       if (used[pos]) {
           quitf(wa_res, "Attempting to place lantern number %d at coordinate %d, but there is already a lantern there", index, pos);
       }
       used[pos] = true;   
       if (dist != x && dist != y) {
          quitf(wa_res, "Invalid lighting distance %d for lantern number %d, only %d or %d are allowed", dist, index, x, y);
       }
       if (a > 0 && dist == x) {
          --a;
       } else if (b > 0 && dist == y) {
          --b;
       } else {
          quitf(wa_res, "Could not install lantern number %d because there are no more lanterns with distance %d", index, dist);
       }
       light[max(pos - dist, 1)] += 1;
       light[min(pos + dist + 1, n + 1)] -= 1;
       if (stream.seekEof()) {
          break;
       }
       pos = stream.readInt();
       dist = stream.readInt();
   }
   int curLenterns = 0;
   for (int i = 1; i <= n; i++) {
      curLenterns += light[i];
      if (curLenterns == 0) {
          quitf(wa_res, "The house at coordinate %d is not lit", i);
      }
   }
   return index;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    long long a = inf.readInt();
    long long x = inf.readInt();
    long long b = inf.readInt();
    long long y = inf.readInt();

    int ca = correctLanternsCount(n, a, x, b, y);
    int ja = solutionLanternsCount(n, a, x, b, y, ans, _fail, _fail);
    if (ja != ca) {
       quitf(_fail, "The jury's and checker's answers did not match (%d, %d)", ja, ca);
    }
    int pa = solutionLanternsCount(n, a, x, b, y, ouf, _wa, _pe);
    if (ja == -1 && pa != -1) {
       quitf(_fail, "The participant found a solution, but the jury did not");
    }
    if (pa == -1 && ja != -1) {
       quitf(_wa, "The solution exists, but the output is -1");
    }
    if (pa < ja) {
       quitf(_fail, "The participant found a better solution than the jury");
    }
    if (pa > ja) {
       quitf(_wa, "The number of lanterns in the participant's solution is %d, it is not minimal (%d in the jury's solution)", pa, ja);
    }
    quitf(_ok, "Correct");
}
